import java.util.Scanner;
import java.util.Random;
/**
 * A program to play multiple games of craps.
 * The program will create a casino like experience with all of the options and thrills of a game of craps.
 * 
 * @Daniel O'Shea (16161777)
 * 
 * Lab week 2
 * 30/01/2017 15:00
 * 
 * Last modified: 14:33 06/02/2017
 * 
 * I added the main method from fig. 6.8 Craps.java into the code.
 * I changed the author and added pseudocode to the areas necessary.
 * I gave the various dice sum nicknames values.
 * I created a method to count the games played, won and lost and display the results.
 */

// plays one game of craps
public class Craps
{// play one game of craps and return true if won, false if lost
    // constants that represent common rolls of the dice
    private static final int SNAKE_EYES = 2;
    private static final int TREY = 3;
    private static final int SEVEN = 7;
    private static final int YO_LEVEN = 11;
    private static final int BOX_CARS = 12;
    
    // create random number generator for use in method rollDice
    private static final Random randomNumbers = new Random(); 
   
    private enum Status { CONTINUE, WON, LOST };
   
    public static boolean playGame()
    {
      int myPoint = 0; // point if no win or loss on first roll
      Status gameStatus; // can contain CONTINUE, WON or LOST

      int counterWin = 0;
      int counterLose = 0;
      
      int sumOfDice = rollDice(); // first roll of the dice

      // determine game status and point based on first roll 
      switch ( sumOfDice ) 
      {
         case SEVEN: // win with 7 on first roll
         case YO_LEVEN: // win with 11 on first roll           
            gameStatus = Status.WON;
            break;
         case SNAKE_EYES: // lose with 2 on first roll
         case TREY: // lose with 3 on first roll
         case BOX_CARS: // lose with 12 on first roll
            gameStatus = Status.LOST;
            break;
         default: // did not win or lose, so remember point         
            gameStatus = Status.CONTINUE; // game is not over
            myPoint = sumOfDice; // remember the point
            System.out.printf( "Point is %d\n", myPoint );
            break; // optional at end of switch
      } // end switch 

      // while game is not complete
      while ( gameStatus == Status.CONTINUE ) // not WON or LOST
      { 
         sumOfDice = rollDice(); // roll dice again

         // determine game status
         if ( sumOfDice == myPoint ) // win by making point
            gameStatus = Status.WON;
         else 
            if ( sumOfDice == SEVEN ) // lose by rolling 7 before point
               gameStatus = Status.LOST;
      } // end while 

      // display won or lost message
      if ( gameStatus == Status.WON ){
         System.out.println( "Player wins" );
         counterWin++;
        }
      else{
         System.out.println( "Player loses" );
         counterLose++;
        }
      System.out.printf( "You played %d games, you won %d and lost %d. Thank you for playing!", counterWin+counterLose, counterWin, counterLose  );  
      
      return ( gameStatus == Status.WON ); // return true if won or false if lost
    } // end of method playGame

    // roll dice, calculate sum and display results
    public static int rollDice()
        {
          // pick random die values
          int die1 = 1 + randomNumbers.nextInt( 6 ); // first die roll
          int die2 = 1 + randomNumbers.nextInt( 6 ); // second die roll
          int sum = die1 + die2; // sum of die values

            // display results of this roll
          System.out.printf( "Player rolled %d + %d = %d\n", 
          die1, die2, sum );
          
          return sum; // return sum of dice
        } // end method rollDice
    
    public static void main( String[] args )
    {
        Scanner keyboard = new Scanner(System.in); // must import java.util.Scanner;
        int game;

        System.out.println("My Game of Craps, Author: Daniel O'Shea 16161777");

        // Counter controlled iteration, describe using pseudo code…
        /**
        *  How many games do you want to play?
        *  User enters number of games
        *  Store number. Keep count of games started
        *  Display what number of game is being started
        */
        System.out.println("How many games would you like to play? ");
        int numberOfGames = keyboard.nextInt();
        for ( game=1; game<=numberOfGames; ++game )
        {
            System.out.printf("\n### Game %d ###\n", game);
            playGame();
        }
        --game; // Actual number of games so far is one less, hence --, why?
        // Because newly started game isn't finshed, and hasn't been fully played yet.
        
        /**
        *  We will play until user says no
        *  Do you want to play?
        *  user enters Y/N
        *  if user enters Y - the game restarts
        *  if user enters N - the game ends and says how many games were played
        */
        System.out.println("\n\nNow lets play again until you say No");
        boolean isPlayAgain;

        do
        {
            System.out.print("\n\nDo you wish to play again (Y/N)? ");
            isPlayAgain = keyboard.next().toUpperCase().equals("Y");
            if ( isPlayAgain )
            {
                System.out.printf("\n###Game %d ###\n", ++game);
                playGame();
            }
        } while ( isPlayAgain );
        System.out.printf("You played %d games. Bye!\n", game );
    } // end of method main
}